function fv_algorithm_B

clc;close all;clear all;

disp('This is a program that make the plot of the field of values of a square');
disp('complex matrix based on the algorithm B of the article title');
disp('Revisiting the inverse field of values problem, submitted for publication');
disp('in the ETNA Special Volume on the occasion of Lothar Reichels 60th birthday');
disp(' ');

disp('Programmers:')
disp('Ana Nata (Polytechnic Institute of Tomar, Portugal)')
disp('e-mail: anata@ipt.pt')
disp('J.P. da Providncia (University of Beira Interior, Covilh, Portugal)') 
disp('e-mail: joaodaprovidencia@daad-alumni.de')
disp('Based on a joint work with Natlia Bebiano and J. da Providncia')
disp('University of Coimbra, Portugal')
disp(' ');
disp('December 2013')
disp(' ');

disp('This file is named as fv_algorithm_A.m');
disp('1. run matlab');
disp('2. input this file fv_algorithm_A.m and the routines fv_2x2_def.m and vect.m');
disp('that can be found on http://www.mat-uc.pt/~bebiano');
disp(' ');
disp('INPUTS:'); 
disp('m = '); %positive integer
disp('enter the elements of a square matrix A')
disp('e.g., A=;')
disp(' ');
disp('OUTPUTS:'); 
disp('Figure that represents the field of values of the matrix A and');
disp('value of the area of the field of values of A');
disp(' ');
disp('INPUTS e.g., m=20; A=[0 -1/2 0;1/2 0 -1/2; 0 1/2 sqrt(2)]');
disp(' ');

%% INPUTS example
m=20; 
A=[0 -1/2 0;1/2 0 -1/2; 0 1/2 sqrt(2)]; 

%%
m=round(m); %m must be a positive integer
    if m<20 %In same cases, it is convenient that m>20
        m=20; 
    end 
    
tic %beginning of the clock time

if ~isequal(size(A,1),size(A,2))
    error('A must be a square matrix');
end

%When A is a scalar matrix
if isequal(A, A(1,1)*eye(size(A,2)))==1
    plot(real(A(1,1)),imag(A(1,1)),'.cyan', 'MarkerSize',5)
    return 
end
    
n=size(A,1);U=[];V=[];
    for r=1:m
        T=(exp(pi*1i*(r-1)/m)*A+exp(-pi*1i*(r-1)/m)*A')/2;
        [Vec,D]=eig(T);
        [s,w] = sort(real(diag(D)));
        x=Vec(:,w(n)); %eigenvector associated to the largest eigenvalue
        y=Vec(:,w(1)); %eigenvector associated to the smaller eigenvalue
        U=[U x];
        V=[V y];
    end   

Mdados1=[];Mdados2=[];j1=1;j2=1;
    for r=1:m-1
        uu1=U(:,r);
        uu2=U(:,r+1);
        [u1 u2]=ortog(uu1,uu2);
        Ac=[]; %The matrix Ac is a 2-dimensional compression matrix of A
        Ac(1,1)=u1'*(A*u1);
        Ac(1,2)=u1'*(A*u2);
        Ac(2,1)=u2'*(A*u1);
        Ac(2,2)=u2'*(A*u2);
        [Mdados1,j1]=fv_2x2_def(Ac,Mdados1,j1); %make the plot of the field of values of Ac

        vv1=V(:,r);
        vv2=V(:,r+1);
        [v1 v2]=ortog(vv1,vv2);
        Bc=[]; %The matrix Bc is a 2-dimensional compression matrix of A
        Bc(1,1)=v1'*(A*v1);
        Bc(1,2)=v1'*(A*v2);
        Bc(2,1)=v2'*(A*v1);
        Bc(2,2)=v2'*(A*v2);
        [Mdados2,j2]=fv_2x2_def(Bc,Mdados2,j2); %make the plot of the field of values of Bc
    end

uu1=U(:,m);
uu2=V(:,1);
[u1 u2]=ortog(uu1,uu2);
Ac=[]; %The matrix Ac is a 2-dimensional compression matrix of A
Ac(1,1)=u1'*(A*u1);
Ac(1,2)=u1'*(A*u2);
Ac(2,1)=u2'*(A*u1);
Ac(2,2)=u2'*(A*u2);
[Mdados1,j1]=fv_2x2_def(Ac,Mdados1,j1); %make the plot of the field of values of Ac

vv1=V(:,m);
vv2=U(:,1);
[v1 v2]=ortog(vv1,vv2);
Bc=[]; %The matrix Bc is a 2-dimensional compression matrix of A
Bc(1,1)=v1'*(A*v1);
Bc(1,2)=v1'*(A*v2);
Bc(2,1)=v2'*(A*v1);
Bc(2,2)=v2'*(A*v2);
[Mdados2,j2]=fv_2x2_def(Bc,Mdados2,j2); %make the plot of the field of values of Bc

ReX=[];ImX=[];
    for s=1:size(Mdados1,1)
        t=linspace(0,2*pi,180);
        c1=Mdados1(s,1);
        c2=Mdados1(s,2);
        a=Mdados1(s,3);
        b=Mdados1(s,4);
        theta=Mdados1(s,5);
        x=a*cos(t);
        y=b*sin(t);
        X=real(cos(theta)*x-sin(theta)*y)+c1;
        Y=real(sin(theta)*x+cos(theta)*y)+c2;
        ReX=[ReX real(X)];ImX=[ImX real(Y)];

        c1=Mdados2(s,1);
        c2=Mdados2(s,2);
        a=Mdados2(s,3);
        b=Mdados2(s,4);
        theta=Mdados2(s,5);
        x=a*cos(t);
        y=b*sin(t);
        X=cos(theta)*x-sin(theta)*y+c1;
        Y=sin(theta)*x+cos(theta)*y+c2;
        ReX=[ReX real(X)];ImX=[ImX real(Y)];
    end

 
Ind=convhull(ReX,ImX);
plot(ReX(Ind),ImX(Ind),'color','blue','linewidth',1.5);
xlabel('Real Axis');
ylabel('Imaginary Axis');
axis equal

toc  %end of the clock time    

%Compute the area inside the curve formed by the points of the convex-hull
Area=polyarea(ReX(Ind),ImX(Ind));
disp(' ');
fprintf('The area is %e \n', Area);
          
